//--------------------------------------------------------------  Alínea A:

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXK 100

#define ALINEA_A 1
#define ALINEA_B 1
#define ALINEA_C 1
#define ALINEA_D 1

void ConstruirSeq(int K, int sequencia[MAXK]) {
	int i;
	sequencia[0] = sequencia[1] = K / 2;
	for (i = 2; i < MAXK; i++)
		sequencia[i] = 0;
}

void MostrarSeq(int sequencia[MAXK]) {
	int i;
	printf("\nSequencia: ");
	for (i = 0; i < MAXK && sequencia[i]>0; i++)
		printf("%d ", sequencia[i]);
}

int LerK() {
	int K;
	printf("Indique K: ");
	scanf("%d", &K);
	if (K < 2 || K>100) {
		printf("\nK tem de ser entre 2 e 100.");
		K = 0;
	}
	return K;
}

#ifdef ALINEA_A
void main()
{
	int K;
	int sequencia[MAXK];
	K = LerK();
	if (K > 0) {
		ConstruirSeq(K, sequencia);
		MostrarSeq(sequencia);
	}
}
#endif

//--------------------------------------------------------------  Alínea B:

int Soma(int sequencia[MAXK]) { 
	int i, soma = 0;
	for (i = 0; i < MAXK && sequencia[i]>0; i++)
		soma += sequencia[i];
	return soma;
}

int Produto(int sequencia[MAXK]) {
	int i, produto = 1;
	for (i = 0; i < MAXK && sequencia[i]>0; i++)
		produto *= sequencia[i];
	return produto;
}

int Tamanho(int sequencia[MAXK]) {
	int i;
	for (i = 0; i < MAXK && sequencia[i]>0; i++);
	return i;
}

int DiferencasABS(int sequencia[MAXK]) {
	int i, j, diferencas = 0, tamanho;
	tamanho = Tamanho(sequencia);
	for (i = 0; i < tamanho - 1; i++)
		for (j = i + 1; j < tamanho; j++)
			diferencas += abs(sequencia[i] - sequencia[j]);
	return diferencas;
}

void LerSeq(int sequencia[MAXK]) {
	int i;
	ConstruirSeq(0, sequencia);
	printf("\nIndique uma sequencia de numeros inteiros positivos, terminando com 0: ");
	i = 0;
	do {
		if (scanf("%d", &(sequencia[i])) == 0)
			sequencia[i] = 0;
		i++;
	} while (sequencia[i - 1] > 0 && i < MAXK);
}

int VerificarSeq(int K, int sequencia[MAXK]) {
	if (Soma(sequencia) > K)
		return 0; // sequência inválida
	if (Produto(sequencia) < K)
		return 0;
	if (DiferencasABS(sequencia) == K)
		return 2; // sequência de vitória
	return 1; // sequência válida
}

#ifdef ALINEA_B
void main()
{
	int K;
	int sequencia[MAXK];
	char* resultados[] = { "invalida","valida","vitoria" };
	K = LerK();
	if (K > 0) {
		LerSeq(sequencia);
		printf("\nSequencia %s", resultados[VerificarSeq(K, sequencia)]);
	}
}
#endif

//--------------------------------------------------------------  Alínea C:

int LerJogada(int jogada[2]) {
	printf("\nJogada (indice valor): ");
	if (scanf("%d %d", &(jogada[0]), &(jogada[1])) == 2)
		return 1;
	return 0;
}

void Remover(int indice, int sequencia[MAXK]) {
	int i;
	// remover posição i, deslocando os elementos após i para a esquerda
	for (i = indice; i < MAXK - 1 && sequencia[i]>0; i++)
		sequencia[i] = sequencia[i + 1];
}

void Inserir(int indice, int valor, int sequencia[MAXK]) {
	int i;
	// deslocar os elementos após i para a direita, e atribuir novo valor
	for (i = MAXK - 1; i > indice; i--)
		sequencia[i] = sequencia[i - 1];
	sequencia[indice] = valor;
}

int ExecutarJogada(int K, int sequencia[MAXK], int jogada[2], int *manterJogador) {
	int i;
	int indice = jogada[0], valor = jogada[1];
	// avançar até ao índice (ou até ao fim da sequência)
	for (i = 0; i < indice && sequencia[i]>0 && i < MAXK; i++);
	if (valor > 0) {
		sequencia[i] = valor; // substituir o valor
		*manterJogador = 0; // passa a vez sempre
	}
	else {
		if (valor == 0) // remover índice i 
			Remover(i, sequencia);
		else // inserir -valor na posição
			Inserir(i, -valor, sequencia);
		*manterJogador = 1 - *manterJogador; // se já estava a ser mantido, deixar de estar, c.c. manter 
	}
	return VerificarSeq(K, sequencia);
}

void JogoSequencia() 
{	// colocado em função, para reutilização na alínea D
	int K, resultado, jogador = 1, njogada = 0, manterJogador = 0;
	int sequencia[MAXK], jogada[2];
	K = LerK();
	if (K > 0) {
		ConstruirSeq(K, sequencia);
		do {
			if (manterJogador == 0)
				jogador = 1 - jogador;
			MostrarSeq(sequencia);
			printf(" [Joga %c] ", 'A' + jogador);
			if (!LerJogada(jogada))
				resultado = 0;
			else
				resultado = ExecutarJogada(K, sequencia, jogada, &manterJogador);
			njogada++;
		} while (resultado == 1 && njogada < K);
		MostrarSeq(sequencia); // última sequência
		if (resultado == 0)
			printf("\nJogador %c perdeu.", 'A' + jogador);
		else if (njogada == K)
			printf("\nEmpate.");
		else
			printf("\nJogador %c ganhou.", 'A' + jogador);
	}
}

#ifdef ALINEA_C
void main()
{
    JogoSequencia(); 
}
#endif


//--------------------------------------------------------------  Alínea D:

#define MAXNJOG 10000

int CriarJogadas(int K, int indice, int sequencia[MAXK], int jogadas[MAXNJOG][2]) {
	int njogadas = 0, i, soma;
	// soma A de todos os valores
	soma = Soma(sequencia);
	// considerar as possibilidades de remover um número ou reduzir
	for (i = 0; i < sequencia[indice]; i++) {
		jogadas[njogadas][0] = indice;
		jogadas[njogadas][1] = i; // novo valor
		njogadas++;
		if (njogadas == MAXNJOG)
			return MAXNJOG;
	}
	if (soma < K) { // considerar também as possibilidades de adicionar um número ou aumentar o atual
		for (i = sequencia[indice]+1; i <= sequencia[indice]+(K-soma); i++) {
			jogadas[njogadas][0] = indice;
			jogadas[njogadas][1] = i; // novo valor
			njogadas++;
			if (njogadas == MAXNJOG)
				return MAXNJOG;
		}
		// colocar novo número
		for (i = 1; i <= K - soma; i++) {
			jogadas[njogadas][0] = indice;
			jogadas[njogadas][1] = -i; // novo valor, negativo para inserir novo número
			njogadas++;
			if (njogadas == MAXNJOG)
				return MAXNJOG;
		}
	}
	return njogadas;
}

int MelhorJogada(int K, int njogadas, int sequencia[MAXK], int jogadas[MAXNJOG][2]) {
	int i, j, resultado, jogada=-1, tamanho=-1, manterJogador=0;
	int seqAux[MAXK];
	// percorrer todas as jogadas
	for (i = 0; i < njogadas; i++) {
		for (j = 0; j < MAXK; j++)
			seqAux[j] = sequencia[j];
		resultado = ExecutarJogada(K, seqAux, jogadas[i], &manterJogador);
		if (resultado == 2) // ganha
			return i;
		if (resultado == 1) { // lance válido
			if (tamanho == -1 || tamanho > Tamanho(seqAux)) {
				tamanho = Tamanho(seqAux);
				jogada = i;
			}
			// não é preciso ter em consideração a soma de todos os números mais baixo
			// atendendo a que as jogadas são criadas por essa ordem
		}
	}
	return jogada;
}

void JogadorArtificial(int K, int sequencia[MAXK], int jogada[2]) {
	int i, indice, valor;
	int jogadas[MAXNJOG][2];
	int njogadas;
	int indicesTestados[MAXK];
	for (i = 0; i < MAXK; i++)
		indicesTestados[i] = 0;
	
	// índice I com o menor valor na sequência

	do {
		for (i = 0, indice = -1; i < MAXK && sequencia[i]>0; i++)
			if ((indice<0 || valor < sequencia[i]) && indicesTestados[i]==0) {
				valor = sequencia[i];
				indice = i;
			}
		if (indice < 0)
			break;
		//printf("\nTeste indice %d.", indice);
		indicesTestados[indice] = 1; // não testar novamente
		njogadas = CriarJogadas(K, indice, sequencia, jogadas);
		i = MelhorJogada(K, njogadas, sequencia, jogadas);
	} while (i < 0); // todas as jogadas inválidas

	if (i < 0) {
		// todas as jogadas inválidas, não fazer nada
		jogada[0] = 0;
		jogada[1] = sequencia[0]; // não faz nada
	}
	else {
		jogada[0] = jogadas[i][0];
		jogada[1] = jogadas[i][1];
	}
}

int LerJogadaGeral(int K, int sequencia[MAXK], int jogada[2]) {
	int resultado = LerJogada(jogada);
	if (resultado && jogada[0] == -2 && jogada[1] == -2) {
		JogadorArtificial(K, sequencia, jogada);
		printf("\nJogada artificial: %d %d", jogada[0], jogada[1]);
	}
	return resultado;
}

#ifdef ALINEA_D
void JogoSequencia()
{	
	int K, resultado, jogador = 1, njogada = 0, manterJogador = 0;
	int sequencia[MAXK], jogada[2];
	K = LerK();
	if (K > 0) {
		ConstruirSeq(K, sequencia);
		do {
			if (manterJogador == 0)
				jogador = 1 - jogador;
			MostrarSeq(sequencia);
			printf(" [Joga %c] ", 'A' + jogador);
			if (!LerJogadaGeral(K, sequencia, jogada)) ///// única alteração para a alínea C
				resultado = 0;
			else
				resultado = ExecutarJogada(K, sequencia, jogada, &manterJogador);
			njogada++;
		} while (resultado == 1 && njogada < K);
		MostrarSeq(sequencia); // última sequência
		if (resultado == 0)
			printf("\nJogador %c perdeu.", 'A' + jogador);
		else if (njogada == K)
			printf("\nEmpate.");
		else
			printf("\nJogador %c ganhou.", 'A' + jogador);
	}
}

void main()
{
	JogoSequencia();
}
#endif

